// This is an open source non-commercial project. Dear PVS-Studio, please check it.
// PVS-Studio Static Code Analyzer for C, C++ and C#: http://www.viva64.com
// ******************************************************************
// *
// *  This file is part of the Cxbx project.
// *
// *  Cxbx and Cxbe are free software; you can redistribute them
// *  and/or modify them under the terms of the GNU General Public
// *  License as published by the Free Software Foundation; either
// *  version 2 of the license, or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2018 ergo720
// *
// *  All rights reserved
// *
// ******************************************************************

#define LOG_PREFIX CXBXR_MODULE::ADM

#include "ADM1032Device.h"
#include "core\kernel\support\Emu.h" // For EmuLog

void ADM1032Device::Init()
{
	// ergo720: these are the values reported by UnleashX on my modded Xbox after half an hour of playing (in celsius)

	m_CPUTemperature = 45;
	m_MBTemperature = 40;
}

uint8_t ADM1032Device::ReadByte(uint8_t command)
{
	if (command == 0x0) { return m_MBTemperature; }
	else if(command == 0x1) { return m_CPUTemperature; }

	EmuLog(LOG_LEVEL::WARNING, "Unknown read command sent to the temperature sensor. The command was %d", command);

	return 0;
}
